#! /bin/bash

gen_instructions()
{
	cd instructions
	for fname in *
	do
		cat $fname | awk -v FNAME="$fname" '

			BEGIN {
				state = 1
				codequote = 0
			}

			function bin2int(bin    ,t,a,c)
			{
				a=1

				for(c=length(bin);c>0;--c)
				{
					t += (substr(bin,c,1)=="1"?a:0)
					a *= 2
				}

				return t
			}

			function print_form(opname, form    ,hex)
			{
				bin = substr(FNAME, 0, 8)
				dec = bin2int(bin)

				print "<li><tt><b>" opname "</b>: " bin "</tt><br>"
				print "<table border=\"1\">"

				if(form=="mbz")
				{
					print  "<tr><td>bits 15-8</td><td>bits 7-0</td></tr>"
					printf "<tr><td><b><tt>0x%02X</tt></b></td><td><i>must be zero</i></td></tr>\n", dec
				}
				else
				if(form=="opdata")
				{
					print  "<tr><td>bits 15-8</td><td>bits 7-0</td></tr>"
					printf "<tr><td><b><tt>0x%02X</tt></b></td><td><b><tt>opdata</tt></b></td></tr>\n", dec
				}
				else
				if(form=="opdata2")
				{
					print  "<tr><td>bits 15-8</td><td>bits 7-0</td><td></td><td>bits 15-0</td></tr>"
					printf "<tr><td><b><tt>0x%02X</tt></b></td><td><b><tt>opdata</tt></b> [23-16]</td><td></td><td><b><tt>opdata</tt></b> [15-0]</td></tr>\n", dec
				}

				print "</table>"
			}

			function end_codequote()
			{
				codequote = 0
				print "</pre></td></tr></table>"
			}

			(state==1) {
				++state
				opname=$1
				next
			}

			(state==2) {
				++state
				form=$1
				print_form(opname, form)
				print "<p>"
				next
			}

			(state==3 && $1=="SINCE") {
				print "(<i>since:</i> <tt>" $2 "</tt>)<br>"
				print "<p>"
				next
			}

			(state==3 && $1=="----" && 0==codequote) {
				codequote = 1
				print "<p>"
				print "<table frame=\"lhs\"><tr><td><pre>"
				next
			}

			(state==3 && $1=="----" && 0!=codequote) {
				end_codequote()
				print "<p>"
				next
			}

			{
				s=$0
				if(codequote) {
					gsub("<", "\\&lt;", s)
					gsub(">", "\\&gt;", s)
				}
				print s
			}

			END {
				if(codequote) {
					end_codequote()
				}

				print "<p>"
				print ""
			}
		'
	done
	cd ..
}

(cat 1-header && gen_instructions && cat 2-footer) >../../doc/tomb.html
