#include <stdio.h>
#include <string.h>
#include "arg.h"
#include "log.h"
#include "dep.h"
#include "db.h"
#include "tmpasm_scconfig.h"

static void wt_set_debug(const char* val)
{
	put("/local/wt/debug", val);
}

static void wt_hook_postinit(void)
{
	db_mkdir("/local");
	put("/local/wt/debug", sfalse);
}

static int wt_hook_detect_host(void)
{
	return 0;
}

static int wt_hook_detect_target(void)
{
	require("sys/ext_exe", 0, 0);
	require("cc/fpic", 0, 0);
	require("cc/wlrpath", 0, 0);
	require("cc/argstd/*", 0, 0);
	require("cc/cc", 0, 0);
	require("cc/cflags", 0, 0);
	require("libs/errno/*", 0, 0);
	require("libs/io/fileno/*", 0, 0);

	return 0;
}

static int wt_hook_generate(const char* root)
{
	int generr = 0;

	fprintf(stderr, "Generating wt/Makefile (%d)\n", generr |= tmpasm(root, "Makefile.in", "Makefile"));
	fprintf(stderr, "Generating wt/config.h (%d)\n", generr |= tmpasm(root, "config.h.in", "config.h"));

	return generr;
}
